# GIMServer
This project allows you to deploy a group of identical monitoring servers that are connected in a peer-to-peer network.
You can interact with any of the servers through a web interface. If you submit a target to monitor to one of the servers,
then the other servers will learn about the target through the peer network, and you will be able to see the results of
all the servers monitoring the network compared side-by-side in the interface.

## Build Locally
This has been tested locally on MacOS and in production on AWS Linux.

You need to run 4 different services - probably best to this in different terminal tabs. Each of these services has
some dependencies. We're going to be trying to recreate most of the contents of `config/configure.sh` locally.


It is recommended that you create a Python virtual environment before you continue. Here's what you'll need:

- Install Python 3.8+
- Install gcc
- Install hping3 and ensure that it's in your `$PATH` as `hping`
- Run `python3.8 -m pip install --user flask flask-cors requests`

Now, you need to decide whether you want your system to integrate with the existing peer-to-peer network. In
case you do, no further action is required at this step - that's the default! If you would like to start your own network, however, you
should remove everything starting on line 2 in the files `src/loop/seed_ips.tsv` and `src/loop/seed_peers.tsv`. 

For all of the following steps, you want to first `cd` into `src/loop`. 

First, initialize the database by running `configure_db.py`.
Now, time to start the services:
- Start the web server: `bash server.sh`
- Start the monitoring loop: `python3.8 loop.py`
- Start the peer server: `python3.8 peer.py`

You can also start the `udpecho` server if you want, although you probably won't be interacting with it:

```bash
gcc src/udpecho.c -o udpecho
./udpecho <port>
```

Now, you can visit the web interface at `http://localhost:5000`.

## Deploy

### Infrastructure
1. First you must configure a group servers running AWS Linux server(s). (The project could be easily updated to run on a wider variety
of Linux distributions, but currently only AWS Linux is actively supported.)

2. You should take the following steps on each server:
   - Ensure they each support the same private key. You can do this by generating a public/private key
pair and appending the public key to the file `.ssh/authorized_keys` in each server. This step must be done manually.
   - Configure the firewall, which you can do for EC2 instances by editing the security group, to allow the following:
      - UDP port 9513, all sources
       - TCP port 80, all sources

3. You should place the private key for the public key you used at the location `~/.ssh/gimserver` on your local machine.

4. Edit the file `config/servers.txt` to contain a whitespace-separated line for each server, in the following format: 

```
server-user server-ip   server-description
```

For instance,
```
ec2-user    1.2.3.4 MyFavoriteServer
```

5. (Optional) Edit the file `src/seed_ips.tsv` to contain any locations that you want to be in the initial
group of locations that are pinged. You can change these later.
   
6. (Optional) Edit the file `src/seed_peers.tsv` to contain a reference to at least one of the servers
you've created - this will be the Master server that all the other servers initially contact to join the peer
   network. An entry is of the form `<display name of server>	<ip address> <port - always 80>`. See the current
   file for an example. If you do not edit this file before deploying, your network of servers will peer with the
   current cluster.
   
7. CD into the `config` directory and run `bash deploy.sh`.

This will likely take around a minute per server to run initially - a lot of dependencies need to be setup.
In the future, if you make source code changes and re-deploy, it should take only about 20 seconds per server.
   
8. When this finishes, if everything worked, you should be able to visit any of the IP addresses for your 
servers on the web and see the standard interface.
